"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const $ = require("chalk");
const elm_view_engine_1 = require("./elm-view-engine");
const elm_view_options_1 = require("./elm-view-options");
function createOptions(pgrm) {
    const options = new elm_view_options_1.default();
    if (pgrm) {
        if (pgrm.views) {
            options.viewsDirPath = pgrm.views;
            options.compilePath = pgrm.views;
        }
        if (pgrm.project) {
            options.projectRoot = pgrm.project;
        }
        if (pgrm.out) {
            options.compilePath = pgrm.out;
        }
    }
    return options;
}
exports.createOptions = createOptions;
function compile(options) {
    // tslint:disable-next-line:no-console
    console.log($.yellow("Starting views compilation..."));
    const eng = new elm_view_engine_1.default(options);
    return eng
        .compile()
        .then(path => {
        // tslint:disable-next-line:no-console
        console.log($.green("Successfully compiled views to ", $.green.bold.underline(path)), false);
    })
        .catch(err => {
        // tslint:disable-next-line:no-console
        console.log($.red("Error compiling: ", $.red.bold(err)));
        throw err;
    });
}
exports.compile = compile;
//# sourceMappingURL=cli-utils.js.map