#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const program = require("commander");
const path = require("path");
const cli_utils_1 = require("./cli-utils");
const version = () => require(path.resolve(__dirname, "./package.json")).version;
program
    .version(version())
    .option("-v, --views <path>", "directory containing all the views")
    .option("-p, --project <path>", "path to the project root")
    .option("-o, --out <path>", "path to the directory where the compiled js file should be outputted")
    .parse(process.argv);
cli_utils_1.compile(cli_utils_1.createOptions(program))
    .then(() => process.exit(0))
    .catch(() => process.exit(1));
//# sourceMappingURL=cli.js.map