export default class Options {
    viewsDirPath: string;
    projectRoot: string;
    expressApp: any;
    forceCompilation: boolean;
    compilePath: string;
    elmMake: string | undefined;
    /**
     * ElmViewEngine options to be passed when constructing
     * @param viewsDirPath Path to the views directory (default: views)
     * @param projectRoot Path to the project's root directory (default: current working directory)
     * @param expressApp Express app to configure with ElmViewEngine as a template engine
     * @param compilePath Path where the compiled views should be outputted (default: viewsDirPath)
     * @param forceCompilation If true, forces views to be recompiled even if there is already an outputted js module
     */
    constructor(viewsDirPath?: string, projectRoot?: string, expressApp?: any, forceCompilation?: boolean, compilePath?: string, elmMake?: string | undefined);
}
