"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
class Options {
    /**
     * ElmViewEngine options to be passed when constructing
     * @param viewsDirPath Path to the views directory (default: views)
     * @param projectRoot Path to the project's root directory (default: current working directory)
     * @param expressApp Express app to configure with ElmViewEngine as a template engine
     * @param compilePath Path where the compiled views should be outputted (default: viewsDirPath)
     * @param forceCompilation If true, forces views to be recompiled even if there is already an outputted js module
     */
    constructor(viewsDirPath = path.join(process.cwd(), "views"), projectRoot = process.cwd(), expressApp, forceCompilation = false, compilePath = viewsDirPath, elmMake) {
        this.viewsDirPath = viewsDirPath;
        this.projectRoot = projectRoot;
        this.expressApp = expressApp;
        this.forceCompilation = forceCompilation;
        this.compilePath = compilePath;
        this.elmMake = elmMake;
    }
}
exports.default = Options;
//# sourceMappingURL=elm-view-options.js.map